import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

import '../start_sdk.dart';

class AppColor {
  AppColor._();

  static const titleColor = Color(0x000000DE);
  static const normalGreyFontColor = Color(0x00000099);
  static const bgGreyColor = Color(0x00F5F5F5);
}

class AppFont {
  AppFont._();

  static const Volte = "Volte";
  static const Volte_Semibold = "Volte-Semibold";
  static const Volte_Medium = "Volte-Medium";
}

class AppStyle {
  static const titleStyle = TextStyle(
    color: Colors.black87,
    fontSize: 20,
    fontFamily: AppFont.Volte,
    fontWeight: FontWeight.w700,
    package: "imepay_merchant_sdk",
  );

  static const titleStyleSemibold = TextStyle(
    color: Colors.black87,
    fontSize: 20,
    fontFamily: AppFont.Volte_Semibold,
    package: "imepay_merchant_sdk",
  );

  static const titleStyleMedium = TextStyle(
    color: Colors.black87,
    fontSize: 20,
    fontFamily: AppFont.Volte_Medium,
    package: "imepay_merchant_sdk",
  );

  static const normalBodyStyle = TextStyle(
    color: Colors.grey,
    fontSize: 14,
    fontFamily: AppFont.Volte_Medium,
    package: "imepay_merchant_sdk",
  );

  static const insideTextFieldStyle = TextStyle(
      color: Colors.black87,
      fontSize: 16,
      package: "imepay_merchant_sdk",
      fontFamily: AppFont.Volte,
      fontWeight: FontWeight.w600);

  static const listItemStyle = TextStyle(
      color: Colors.black54,
      fontSize: 16,
      package: "imepay_merchant_sdk",
      fontFamily: AppFont.Volte,
      fontWeight: FontWeight.w600);

  static const footerListStyle = TextStyle(
      color: Colors.black87,
      fontSize: 16,
      package: "imepay_merchant_sdk",
      fontFamily: AppFont.Volte,
      fontWeight: FontWeight.w600);

  static const secondaryTitleStyle = TextStyle(
      color: Colors.black54,
      fontSize: 14,
      package: "imepay_merchant_sdk",
      fontFamily: AppFont.Volte,
      fontWeight: FontWeight.w600);

  static const labelStyle = TextStyle(
      color: Colors.grey,
      fontSize: 16,
      package: "imepay_merchant_sdk",
      fontFamily: AppFont.Volte,
      fontWeight: FontWeight.w600);
}

class ErrorMessage {
  static final String RESPONSE_IO_ERROR =
      "Connection could not be established.";

  //When the expected json string doesnot match with obtained json string
  static final String RESPONSE_FORMAT_ERROR = "Response could not be parsed.";

  //When the obtained token is empty
  static final String RESPONSE_EMPTY_TOKEN_ERROR = "Token is not generated.";

  static final String GET_TOKEN_ERROR_CODE = " (ErrorCode: x101).";
  static final String POST_TO_MERCHANT_ERROR_CODE = " (ErrorCode: x102).";
}

class ResponseStatus {
  static final int RESPONSE_STATUS_POSITIVE = 1;

  static final int RESPONSE_STATUS_NEGATIVE = -1;
}

class ApiConstants {
  static const STAGE_URL = "https://stg.imepay.com.np:7979/api/";
  static const LIVE_URL = "https://payment.imepay.com.np:7979/api/";
  static const GET_TOKEN = "Web/GetToken";
  static const VALIDATE_USER = "Web/V2/ValidateUser";
  static const VALIDATE_OTP = "Web/V2/ValidateOTP";
  static const CONFIRM_PAYMENT = "Web/Confirm";
  static const PAYMENT = "Web/Payment";
  static BuildType? buildType = BuildType.STAGE;

  static String getSelectedBaseUrl() {
    return buildType == BuildType.LIVE ? LIVE_URL : STAGE_URL;
  }
}

class AppConstants {
  static String RESPOSNE_TOKEN = "";
}
