class MobileVerifyModel {
    String? accCode;
    String? merchantCode;
    String? msisdn;
    String? otp;
    String? refId;
    int? responseCode;
    String? responseDescription;
    String? signature;
    String? tokenId;
    String? transactionId;
    String? uniqueCode;

    MobileVerifyModel({this.accCode, this.merchantCode, this.msisdn, this.otp, this.refId, this.responseCode, this.responseDescription, this.signature, this.tokenId, this.transactionId, this.uniqueCode});

    //{"RefId":"EA1252ed302","ResponseCode":"0","ResponseDescription":null,"TokenId":"202111161451417221","Amount":"200000.0000"}
    factory MobileVerifyModel.fromJson(Map<String, dynamic> json) {
        return MobileVerifyModel(
            msisdn: json['Msisdn'],
            accCode: json['AccCode'],
            merchantCode: json['merchantCode'],
            otp: json['otp'],
            refId: json['RefId'],
            responseCode: json['ResponseCode'],
            signature: json['signature'],
            tokenId: json['TokenId'],
            transactionId: json['TranId'],
            responseDescription: json['ResponseDescription'],
            uniqueCode: json['uniqueCode'],
        );
    }

    Map<String, dynamic> toJson() {
        final Map<String, dynamic> data = new Map<String, dynamic>();
        data['Msisdn'] = this.msisdn;
        data['otp'] = this.otp;
        data['responseCode'] = this.responseCode;
        data['responseDescription'] = this.responseDescription;
        data['signature'] = this.signature;
        data['refId'] = this.refId;
        data['merchantCode'] = this.merchantCode;
        data['AccCode'] = this.accCode;
        data['tokenId'] = this.tokenId;
        data['TranId'] = this.transactionId;
        data['uniqueCode'] = this.uniqueCode;
        return data;
    }
}