import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import '/constants/app_constants.dart';
import '/model/request_model.dart';
import '/phone_number_screen.dart';
import '/webservice/web_service.dart';

import 'views/verify_screen.dart';

class StartSdk {
  static Object? _finalResult;

  static Future<Object?> callSdk(
    BuildContext context, {
    required String merchantCode,
    required String merchantName,
    required String merchantUrl,
    required String amount,
    required String refId,
    required String module,
    required String user,
    required String password,
    required String customerName,
    required String deliveryUrl,
    required BuildType buildType,
    required String logo,
  }) async {
    ApiConstants.buildType = buildType;
    print("merchant code= $merchantCode");

    String m = base64.encode(utf8.encode(module));

    RequestModel requestModel = new RequestModel(
        merchantName: merchantName,
        merchantCode: merchantCode,
        merchantUrl: merchantUrl,
        amount: amount,
        refId: refId,
        module: m,
        customerName: customerName,
        user: user,
        password: password,
        deliveryUrl: deliveryUrl,
        logo: logo);

    await Navigator.push(
      context,
      MaterialPageRoute(builder: (context) => PhoneNumberScreen(requestModel)),
    );

    return _finalResult;
  }

  static Future<Object?> setResult(BuildContext context, Object? result) async {
    if (result != null) {
      _finalResult = await result;
    }

    // Navigator.pop(context, result);

    return _finalResult;
  }
}

enum BuildType { STAGE, LIVE }
