import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import '/constants/app_constants.dart';
import '/model/payment_response_model.dart';
import '/model/request_model.dart';
import '/start_sdk.dart';
import '/utils/utils.dart';
import '/views/loadin_overlay.dart';
import '/webservice/web_service.dart';
import 'dart:async';
import 'error_screen.dart';
import 'success_screen.dart';

class VerifyScreen extends StatefulWidget {
  RequestModel? requestModel;
  String? msisdn;
  String? walletPin;

  VerifyScreen(this.requestModel, this.msisdn, this.walletPin);

  @override
  _VerifyScreenState createState() => _VerifyScreenState();
}

class _VerifyScreenState extends State<VerifyScreen>
    with TickerProviderStateMixin {
  TextEditingController fistTextController = new TextEditingController();
  TextEditingController secondTextcontroller = new TextEditingController();
  TextEditingController thirdTextController = new TextEditingController();
  TextEditingController fourthTextController = new TextEditingController();
  FocusNode focusOne = new FocusNode();
  FocusNode focusTwo = new FocusNode();
  FocusNode focusThree = new FocusNode();
  FocusNode focusFour = new FocusNode();
  int focusPosition = 1;
  bool isFloatingActive = false;
  final _formKey = GlobalKey<FormState>();
  final _pinPutController = TextEditingController();
  final _pinPutFocusNode = FocusNode();
  final _pageController = PageController();
  late AnimationController _controller;
  final GlobalKey<ScaffoldState> _scaffoldKey = new GlobalKey<ScaffoldState>();
  var timer;

  String pin = "";
  List<String> gridViewList = [
    "1",
    "2",
    "3",
    "4",
    "5",
    "6",
    "7",
    "8",
    "9",
    "CANCEL",
    "0",
    "-1"
  ];
  String phoneNumber = "";
  bool loading = false;
  String minute = "05";
  String secondValue = "0";
  bool isRetry = false;

  @override
  initState() {
    super.initState();

    phoneNumber = widget.msisdn.toString();
    _controller = AnimationController(
        vsync: this,
        duration: Duration(
            minutes:
                5) // gameData.levelClock is a user entered number elsewhere in the applciation
        );

    _controller.forward();
    sec5Timer();
  }

  @override
  Widget build(BuildContext context) {
    return WillPopScope(
      onWillPop: () async {
        showDialog(
          context: context,
          builder: (BuildContext context) {
            return AlertDialog(
              content: const Text('Do you really want to abort the payment?'),
              actions: <Widget>[
                TextButton(
                  onPressed: () {
                    Navigator.pop(context);
                  },
                  child: const Text('No'),
                ),
                TextButton(
                  onPressed: () {
                    StartSdk.setResult(
                      context,
                      PaymentResponseModel(
                          responseDescription:
                              "Transaction cancel by user. RefId= ${widget.requestModel!.refId.toString()}",
                          responseCode: -1),
                    );

                    Navigator.pop(context);
                    Navigator.pop(context);
                  },
                  child: const Text('Yes'),
                ),
              ],
            );
          },
        );
        return false;
      },
      child: LoadingOverlay(
        progressIndicator: CircularProgressIndicator(
          color: Colors.red,
        ),
        color: Colors.black.withOpacity(0.5),
        isLoading: loading,
        child: Scaffold(
            key: _scaffoldKey,
            backgroundColor: Colors.white,
            appBar: AppBar(
              backgroundColor: Colors.white,
              toolbarHeight: 56,
              elevation: 0,
              leading: InkWell(
                  onTap: () {
                    showDialog(
                      context: context,
                      builder: (BuildContext context) {
                        return AlertDialog(
                          content: const Text(
                              'Do you really want to abort the payment?'),
                          actions: <Widget>[
                            TextButton(
                              onPressed: () {
                                Navigator.pop(context,
                                    "Transaction cancel by user. RefId= ${widget.requestModel?.refId}");
                              },
                              child: const Text('No'),
                            ),
                            TextButton(
                              onPressed: () {
                                StartSdk.setResult(
                                  context,
                                  PaymentResponseModel(
                                      responseDescription:
                                          "Transaction cancel by user. RefId= ${widget.requestModel!.refId.toString()}",
                                      responseCode: -1),
                                );
                                Navigator.pop(context);
                                Navigator.pop(context);
                              },
                              child: const Text('Yes'),
                            ),
                          ],
                        );
                      },
                    );
                  },
                  child: Icon(
                    Icons.arrow_back_outlined,
                    color: Colors.black54,
                  )),
            ),
            body: _bodyWidget()),
      ),
    );
  }

  Widget _bodyWidget() {
    return Container(
        padding: EdgeInsets.all(Utils.getSizeInt(context, 16)),
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          children: <Widget>[
            Column(
              children: [
                Text(
                  "4- digit code",
                  style: AppStyle.titleStyleSemibold,
                ),
                SizedBox(
                  height: 8,
                ),
                Text(
                  "Please enter the code sent to $phoneNumber",
                  style: AppStyle.normalBodyStyle,
                ),
                SizedBox(
                  height: 16,
                ),
                Row(
                  mainAxisAlignment: MainAxisAlignment.center,
                  children: [
                    Container(
                        width: Utils.getSizeInt(context, 48),
                        height: Utils.getSizeInt(context, 48),
                        child: FocusScope(
                            child: Focus(
                                onFocusChange: (focus) {
                                  if (focus) focusPosition = 1;
                                },
                                child: TextFormField(
                                    onChanged: (value) {
                                      if (value.trim().isNotEmpty) {
                                        // changeTextFocus();
                                        // validateAllData();
                                      }
                                    },
                                    showCursor: true,
                                    readOnly: true,
                                    focusNode: focusOne,
                                    autofocus: true,
                                    keyboardType: TextInputType.number,
                                    controller: fistTextController,
                                    textAlign: TextAlign.center,
                                    style: AppStyle.titleStyleMedium,
                                    maxLength: 1,
                                    decoration: new InputDecoration(
                                        contentPadding: EdgeInsets.all(8),
                                        counterText: "",
                                        fillColor: Colors.white,
                                        border: OutlineInputBorder(
                                            borderRadius: BorderRadius.all(
                                                Radius.circular(4)),
                                            borderSide: BorderSide(
                                              width: 2,
                                            ))))))),
                    Container(
                        margin: EdgeInsets.only(left: 8),
                        width: Utils.getSizeInt(context, 48),
                        height: Utils.getSizeInt(context, 48),
                        child: FocusScope(
                            child: Focus(
                                onFocusChange: (focus) {
                                  if (focus) focusPosition = 2;
                                },
                                child: TextFormField(
                                    onChanged: (value) {
                                      if (value.trim().isNotEmpty) {
                                        // changeTextFocus();
                                        // validateAllData();
                                      }
                                    },
                                    focusNode: focusTwo,
                                    showCursor: true,
                                    readOnly: true,
                                    keyboardType: TextInputType.number,
                                    controller: secondTextcontroller,
                                    textAlign: TextAlign.center,
                                    style: AppStyle.titleStyleMedium,
                                    maxLength: 1,
                                    decoration: new InputDecoration(
                                        contentPadding: EdgeInsets.all(8),
                                        counterText: "",
                                        fillColor: Colors.white,
                                        border: OutlineInputBorder(
                                            borderRadius: BorderRadius.all(
                                                Radius.circular(4)),
                                            borderSide: BorderSide(
                                              width: 2,
                                            ))))))),
                    Container(
                        margin: EdgeInsets.only(left: 8),
                        width: Utils.getSizeInt(context, 48),
                        height: Utils.getSizeInt(context, 48),
                        child: FocusScope(
                            child: Focus(
                                onFocusChange: (focus) {
                                  if (focus) focusPosition = 3;
                                },
                                child: TextFormField(
                                    focusNode: focusThree,
                                    keyboardType: TextInputType.number,
                                    onChanged: (value) {
                                      if (value.trim().isNotEmpty) {
                                        // changeTextFocus();
                                        // validateAllData();
                                      }
                                    },
                                    controller: thirdTextController,
                                    textAlign: TextAlign.center,
                                    style: AppStyle.titleStyleMedium,
                                    showCursor: true,
                                    readOnly: true,
                                    maxLength: 1,
                                    decoration: new InputDecoration(
                                        contentPadding: EdgeInsets.all(8),
                                        counterText: "",
                                        fillColor: Colors.white,
                                        border: OutlineInputBorder(
                                            borderRadius: BorderRadius.all(
                                                Radius.circular(4)),
                                            borderSide: BorderSide(
                                              width: 2,
                                            ))))))),
                    Container(
                        margin: EdgeInsets.only(left: 8),
                        width: Utils.getSizeInt(context, 48),
                        height: Utils.getSizeInt(context, 48),
                        child: FocusScope(
                            child: Focus(
                                onFocusChange: (focus) {
                                  if (focus) focusPosition = 4;
                                },
                                child: TextFormField(
                                    focusNode: focusFour,
                                    keyboardType: TextInputType.number,
                                    onChanged: (value) {
                                      if (value.trim().isNotEmpty) {
                                        // changeTextFocus();
                                        // validateAllData();
                                      }
                                    },
                                    controller: fourthTextController,
                                    textAlign: TextAlign.center,
                                    style: AppStyle.titleStyleMedium,
                                    maxLength: 1,
                                    showCursor: true,
                                    readOnly: true,
                                    decoration: new InputDecoration(
                                        contentPadding: EdgeInsets.all(8),
                                        counterText: "",
                                        fillColor: Colors.white,
                                        border: OutlineInputBorder(
                                            borderRadius: BorderRadius.all(
                                                Radius.circular(4)),
                                            borderSide: BorderSide(
                                              width: 2,
                                            ))))))),
                  ],
                ),
              ],
            ),
            Column(
              children: [
                SizedBox(
                  height: Utils.getSizeInt(context, 60),
                ),
                Center(
                    child: RichText(
                  text: TextSpan(
                    text: 'You can retry in ',
                    style: AppStyle.normalBodyStyle,
                    children: <TextSpan>[
                      TextSpan(
                          text: minute,
                          style: TextStyle(
                            color: Color(0xFFCC0000),
                            fontSize: 14,
                            fontFamily: AppFont.Volte_Semibold,
                            package: "imepay_merchant_sdk",
                          )),
                      TextSpan(text: ' mins '),
                      TextSpan(
                          text: secondValue,
                          style: TextStyle(
                            color: Color(0xFFCC0000),
                            fontSize: 14,
                            fontFamily: AppFont.Volte_Semibold,
                            package: "imepay_merchant_sdk",
                          )),
                      TextSpan(text: ' secs.'),
                    ],
                  ),
                )),
                SizedBox(
                  height: Utils.getSizeInt(context, 35),
                ),
                Visibility(
                  visible: isRetry,
                  child: InkWell(
                      onTap: () {
                        setState(() {
                          loading = true;
                          isRetry = false;
                          pin = "";
                        });
                        Webservice()
                            .requestForOTP(widget.requestModel!,
                                widget.msisdn.toString(), widget.walletPin)
                            .then((response) {
                          setState(() {
                            loading = false;
                          });
                          switch (response!.responseCode) {
                            case -1:
                              setState(() {
                                pin = "";
                              });
                              final snackBar = SnackBar(
                                content: Text(ErrorMessage
                                        .RESPONSE_FORMAT_ERROR +
                                    ErrorMessage.POST_TO_MERCHANT_ERROR_CODE),
                                action: SnackBarAction(
                                  label: 'Ok',
                                  onPressed: () {
                                    _scaffoldKey.currentState!
                                        .hideCurrentSnackBar();
                                  },
                                ),
                              );
                              _scaffoldKey.currentState!.showSnackBar(snackBar);

                              break;

                            case 100:
                              setState(() {
                                timer.cancel();
                                sec5Timer();
                              });

                              break;

                            case 101:
                              setState(() {
                                pin = "";
                              });
                              final snackBar = SnackBar(
                                content: Text(
                                    response.responseDescription.toString()),
                                action: SnackBarAction(
                                  label: 'Ok',
                                  onPressed: () {
                                    _scaffoldKey.currentState!
                                        .hideCurrentSnackBar();
                                  },
                                ),
                              );
                              _scaffoldKey.currentState!.showSnackBar(snackBar);
                              break;

                            case 102:
                              setState(() {
                                pin = "";
                              });
                              final snackBar = SnackBar(
                                content: Text(
                                    response.responseDescription.toString()),
                                action: SnackBarAction(
                                  label: 'Ok',
                                  onPressed: () {
                                    _scaffoldKey.currentState!
                                        .hideCurrentSnackBar();
                                  },
                                ),
                              );
                              _scaffoldKey.currentState!.showSnackBar(snackBar);
                              break;

                            case 115:
                              final snackBar = SnackBar(
                                content: Text(
                                    response.responseDescription.toString()),
                                action: SnackBarAction(
                                  label: 'Ok',
                                  onPressed: () {
                                    _scaffoldKey.currentState!
                                        .hideCurrentSnackBar();
                                  },
                                ),
                              );
                              _scaffoldKey.currentState!.showSnackBar(snackBar);

                              break;
                          }
                        });
                      },
                      child: Text(
                        'Retry',
                        style: TextStyle(
                            color: Colors.blue,
                            fontSize: 16,
                            package: "imepay_merchant_sdk",
                            fontFamily: AppFont.Volte_Semibold,
                            fontWeight: FontWeight.w600),
                      )),
                )
              ],
            ),
            _keyPadLayout()
          ],
        ));
  }

  changeTextFocus() {
    if (focusPosition == 1) {
      FocusScope.of(context).requestFocus(focusTwo);
    } else if (focusPosition == 2) {
      FocusScope.of(context).requestFocus(focusThree);
    } else if (focusPosition == 3) {
      FocusScope.of(context).requestFocus(focusFour);
    } else if (focusPosition == 4) {
      FocusScope.of(context).requestFocus(focusFour);
    } else {
      // focusPosition = -1;
      // FocusScope.of(context).unfocus();
    }
  }

  validateAllData() {
    if (fistTextController.text.isNotEmpty &&
        secondTextcontroller.text.isNotEmpty &&
        thirdTextController.text.isNotEmpty &&
        fourthTextController.text.isNotEmpty) {
      setState(() {
        loading = true;
        Webservice()
            .validateOtp(
                widget.requestModel!,
                widget.msisdn.toString(),
                fistTextController.text.toString() +
                    secondTextcontroller.text.toString() +
                    thirdTextController.text.toString() +
                    fourthTextController.text.toString())
            .then((response) {
          if (response != null) {
            switch (response.responseCode) {
              case -1:
                setState(() {
                  loading = false;
                });

                final snackBar = SnackBar(
                  content: Text(ErrorMessage.RESPONSE_FORMAT_ERROR),
                  action: SnackBarAction(
                    label: 'OK',
                    onPressed: () {
                      _scaffoldKey.currentState!.hideCurrentSnackBar();
                    },
                  ),
                );
                _scaffoldKey.currentState!.showSnackBar(snackBar);
                break;
              case 1:
                setState(() {
                  loading = false;
                });
                fistTextController.text = "";
                secondTextcontroller.text = "";
                thirdTextController.text = "";
                fourthTextController.text = "";
                FocusScope.of(context).requestFocus(focusOne);
                final snackBar = SnackBar(
                  content: Text(response.responseDescription.toString()),
                  action: SnackBarAction(
                    label: 'OK',
                    onPressed: () {
                      _scaffoldKey.currentState!.hideCurrentSnackBar();
                    },
                  ),
                );
                _scaffoldKey.currentState!.showSnackBar(snackBar);
                break;
              case 0:
                performPayment(
                    response.refId.toString(), response.tokenId.toString());

                break;
            }
          }
        });
      });
    } else {
      isFloatingActive = false;
    }
  }

  _keyPadLayout() {
    return GridView.count(
      shrinkWrap: true,
      padding: EdgeInsets.all(Utils.getSizeInt(context, 16)),
      crossAxisCount: 3,
      childAspectRatio:
          (Utils.getSizeInt(context, 80) / Utils.getSizeInt(context, 50)),
      children: gridViewList.map((value) {
        return InkWell(
          onTap: () {
            if (value == "CANCEL") {
              Navigator.pop(context);
            } else if (value == "-1") {
              String selectedPin = "";
              if (focusPosition == 1) {
                setState(() {
                  fistTextController.text = "";
                });
              } else if (focusPosition == 2) {
                setState(() {
                  secondTextcontroller.text = "";
                });
                FocusScope.of(context).requestFocus(focusOne);
              } else if (focusPosition == 3) {
                setState(() {
                  thirdTextController.text = "";
                });
                FocusScope.of(context).requestFocus(focusTwo);
              } else if (focusPosition == 4) {
                setState(() {
                  fourthTextController.text = "";
                });
                FocusScope.of(context).requestFocus(focusThree);
              } else {}
              validateAllData();
            } else {
              if (focusPosition == 1) {
                setState(() {
                  fistTextController.text = value;
                });
              } else if (focusPosition == 2) {
                setState(() {
                  secondTextcontroller.text = value;
                });
              } else if (focusPosition == 3) {
                setState(() {
                  thirdTextController.text = value;
                });
              } else if (focusPosition == 4) {
                setState(() {
                  fourthTextController.text = value;
                });
              } else {}
              changeTextFocus();
              validateAllData();
            }
          },
          child: Container(
            alignment: Alignment.center,
            margin: EdgeInsets.all(1),
            child: value == "-1"
                ? Image(
                    image: AssetImage("lib/assets/images/backspace.png",
                        package: "imepay_merchant_sdk"),
                    width: 24,
                  )
                : Text(
                    value,
                    style: value == "CANCEL"
                        ? TextStyle(
                            color: Colors.black,
                            fontSize: 14,
                            package: "imepay_merchant_sdk",
                            fontFamily: AppFont.Volte_Semibold)
                        : AppStyle.titleStyleSemibold,
                  ),
          ),
        );
      }).toList(),
    );
  }

  @override
  void dispose() {
    _controller.dispose();
    super.dispose();
  }

  confirmPayment(PaymentResponseModel paymentResponseModel) {
    Webservice()
        .confirmPayment(widget.requestModel!, widget.msisdn.toString(),
            paymentResponseModel.transactionId.toString())
        .then((response) async {
      timer.cancel();
      if (this.mounted) {
        setState(() {
          loading = false;
        });
      }

      if (response != null) {
        if (response.responseCode == 1) {
          await Navigator.push(
              context,
              MaterialPageRoute(
                  builder: (context) => ErrorScreen(
                      widget.requestModel,
                      widget.msisdn.toString(),
                      widget.walletPin.toString(),
                      AppConstants.RESPOSNE_TOKEN,
                      response.responseDescription)
                  // SuccessScreen(widget.requestModel, paymentResponseModel),
                  ));
          Navigator.pop(context);
        } else {
          paymentResponseModel.merchantCode =
              widget.requestModel!.merchantCode.toString();

          paymentResponseModel.refId = widget.requestModel!.refId.toString();

          await Navigator.push(
              context,
              MaterialPageRoute(
                  builder: (context) => SuccessScreen(
                      widget.requestModel, paymentResponseModel)));

          Navigator.pop(context);
        }
      } else {
        await Navigator.push(
            context,
            MaterialPageRoute(
                builder: (context) => ErrorScreen(
                    widget.requestModel,
                    widget.msisdn.toString(),
                    widget.walletPin.toString(),
                    AppConstants.RESPOSNE_TOKEN,
                    response?.responseDescription)
                // SuccessScreen(widget.requestModel, paymentResponseModel),
                ));
        Navigator.pop(context);
      }
    });
  }

  performPayment(String refId, String tokenId) {
    Webservice()
        .performTransaction(widget.requestModel!, widget.msisdn.toString(),
            widget.walletPin.toString(), AppConstants.RESPOSNE_TOKEN)
        .then((response) {
      if (response != null) {
        if (response.responseCode == -1) {
          if (this.mounted) {
            setState(() {
              loading = false;
            });
          }

          final snackBar = SnackBar(
            content: Text(ErrorMessage.RESPONSE_FORMAT_ERROR),
            action: SnackBarAction(
              label: 'OK',
              onPressed: () {
                _scaffoldKey.currentState!.hideCurrentSnackBar();
              },
            ),
          );
          _scaffoldKey.currentState!.showSnackBar(snackBar);
        } else if (response.responseCode == 1) {
          if (this.mounted) {
            setState(() {
              loading = false;
            });
          }

          final snackBar = SnackBar(
            duration: Duration(milliseconds: 500000),
            content: Text(response.responseDescription.toString()),
            action: SnackBarAction(
              label: 'OK',
              onPressed: () {
                _scaffoldKey.currentState!.hideCurrentSnackBar();
              },
            ),
          );
          _scaffoldKey.currentState!.showSnackBar(snackBar);
        } else {
          confirmPayment(response);
        }
      } else {
        if (this.mounted) {
          setState(() {
            loading = false;
          });
        }

        final snackBar = SnackBar(
          duration: Duration(milliseconds: 500000),
          content: Text("Something went wrong!"),
          action: SnackBarAction(
            label: 'Retry',
            onPressed: () {
              _scaffoldKey.currentState!.hideCurrentSnackBar();
            },
          ),
        );
        _scaffoldKey.currentState!.showSnackBar(snackBar);
      }
    });
  }

  bool isStopped = false; //global
  int totalTime = 300;
  int count = 0;

  sec5Timer() {
    int count = 0;
    int remainingTime = 300;
    int m = 5;
    int sec = 0;
    timer = Timer.periodic(Duration(seconds: 1), (timer) {
      if (remainingTime == 0) {
        if (this.mounted) {
          setState(() {
            isRetry = true;
          });
        }
        timer.cancel();
      } else {
        remainingTime = totalTime - count;
        m = (remainingTime / 60).floor();
        sec = remainingTime.remainder(60);
      }
      if (this.mounted) {
        setState(() {
          minute = m.toString();
          secondValue = sec.toString();
        });
      }

      count = count + 1;
    });
  }
}
