import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import '/constants/app_constants.dart';

class CustomTextInputField extends StatefulWidget {
  String? label;
  String? hint;
  String? error;
  bool? isEnable;
  bool? readonly;
  FormFieldValidator<String>? onChanged;
  TextEditingController? controller = TextEditingController();
  VoidCallback? onTap;
  IconData? icon;
  int? maxLenght;
  TextInputType textInputType;

  CustomTextInputField(
      {this.label, this.hint, this.onChanged, this.error, this.isEnable = true, this.controller,
        this.readonly = false, this.onTap, this.icon, this.textInputType = TextInputType.text, this.maxLenght = 10});

  @override
  _CustomTextInputFieldState createState() => _CustomTextInputFieldState();
}

class _CustomTextInputFieldState extends State<CustomTextInputField> {
  @override
  Widget build(BuildContext context) {
    return Container(
      height: 48,
      child: TextField(
          controller: widget.controller,
          style: AppStyle.insideTextFieldStyle,
          onChanged: widget.onChanged,
          keyboardType: widget.textInputType,
          enabled: widget.isEnable,
          readOnly: widget.readonly!,
          onTap: widget.onTap,
          maxLength: widget.maxLenght,
          decoration: InputDecoration(
            counterText: '',
            suffixIcon: widget.icon != null ? Icon(
                widget.icon, color: Colors.grey,) : null,
              labelStyle: AppStyle.labelStyle,
              labelText: widget.hint,
              contentPadding: EdgeInsets.only(bottom: 5, left: 10),
              border: OutlineInputBorder(
              )

          )),
    );
  }
}
